<?
//=================================================
//explore l'arborescence du site et cree la table temporaire des fichiers a indexer
function list_dir ($path,$step)
{
    global $cfgUser,$ext,$root;

	if ($dir = @opendir($path))
    {
        while($file = readdir($dir))
        {
            if ($file !="." && $file != "..")
            {
                if (is_dir($path."/".$file))
                {
                    list_dir ($path."/".$file, $step+1);
                }
                else
                {
                    
					$iext=0;
					$true=0;
					while ($ext[$iext])//on verifie si le fichier a la bonne extention
					{
						$extention=strrchr( $file , "." );
						if(strtolower($extention)==strtolower('.'.$ext[$iext]))
						{
							$true=1;
						}
						$iext++;
					}
					if ($true==1)
					{
						$parent=substr($path,strlen($root)+1);
						if (!$parent) $parent=" root";
						$query="INSERT INTO exploreur(adresse,parent,profondeur) VALUES ('$path/$file','$parent','$step')";
						mysql_db_query($cfgUser,$query);
					}
                }
            }
        }
        closedir($dir);
    }
    else
        echo "<b>ERREUR : $path</b> n'est pas un dossier !!\n<br>";
}

//=====================================
//Affiche une icone diffrente en fonction du type de fichier
function extension($file)
{  
    $ext = strrchr( $file , "." );
    ############### Folder
    if ( $file == "folder" )
    {
        $gifn  = "<IMG SRC='../images/folder.gif' alt='Dossier' border='0' width='16' ";
        $gifn .= "height='16' hspace='3' vspace='3'>";
       
        ############### Webscript
    }
    else if ((!strcasecmp($ext, ".phps")) || (!strcasecmp($ext, ".php")) || 
             (!strcasecmp($ext, ".php2")) || (!strcasecmp($ext, ".php3")) || 
             (!strcasecmp($ext, ".php4")) || (!strcasecmp($ext, ".phtml")) || 
             (!strcasecmp($ext, ".asp")) || (!strcasecmp($ext, ".asa")) || 
             (!strcasecmp($ext, ".cgi")) || (!strcasecmp($ext, ".shtml")) || 
             (!strcasecmp($ext, ".pl")))
    {
        $gifn = "<IMG SRC='../images/webscript.gif' alt='Web program' border='0' ";
        $gifn .= "width='15' height='15' hspace='3' vspace='2'>";
        
        ############### Web page
    }
    else if ((!strcasecmp($ext, ".html")) || (!strcasecmp($ext, ".htm")))
    {
        $gifn = "<IMG SRC='../images/webpage.gif' alt='Web page' border='0' width='16' ";
        $gifn .= "height='16' hspace='3' vspace='2'>";
        ############### WAP page
    }
    else if (!strcasecmp($ext, ".wml"))
    {
        $gifn = "<IMG SRC='../images/webscript.gif' alt='WAP page' border='0' ";
        $gifn .= "width='16' height='16' hspace='3' vspace='2'>";
	}
    return $gifn;
}


//=================================================
//fait des tabulation en fonction de la profondeur du fichier
function indent($max)
{
    for ($i=1;$i<$max;$i++) 
        echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
}

//================================================
//affiche l'arbre des dossiers
function affiche_arbre($arbre)
{
	while($row=mysql_fetch_row($arbre))
	{
		if ($row[1]!=$dernier_dossier)//on change de repertoire donc on va afficher le nom du rpertoire avant les fichiers
		{
			indent($row[2]);
			if($row[3]==1)$selection=0;
			elseif ($row[3]==0) $selection=1;
			
			
			$anchor="<a NAME='$row[1]'></a>";
			$lien="<a class='lien' href='selectionfichier.php3?folder=$row[1]&selectionne=$selection#$row[1]'>";
			print $anchor;
			print extension("folder")."$lien$row[1]</a>\n<br>";
		}
		indent($row[2]+1);
		if($row[3]==1)
			{
				$class="class=vert";
				$selection=0;
			}
			elseif($row[3]==0)
			{
				$class="class=rouge";
				$selection=1;
			}
			elseif($row[3]==2)
			{
				$class="class=vertfonce";
				$selection=3;
			}
			elseif($row[3]==3)
			{
				$class="class=orange";
				$selection=2;
			}
			

		$lien="<a $class href='selectionfichier.php3?file=$row[0]&selectionne=$selection#$row[1]'>";
		print extension($row[0])."$lien$row[0]</a>\n<br>";
		$dernier_dossier=$row[1];
	}
	
}




//=================================================
//Rcupre le titre
function get_title($text,$file)
{
	$debut_titre = strpos($text, "<title>") + 7;
	$fin_titre = strpos($text, "</title>");
	$longueur = $fin_titre - $debut_titre;
	if ($fin_titre != "" && $longueur != 0)
	{
		$titre = substr($text, $debut_titre, $longueur);
	}
	else
	{
		$titre = $file;
	}
	return $titre;
}

//=================================================
//Rcupere les motsclefs
function get_keywords($text)
{
	$text=strtolower($text);//on met en minuscules
	if(!$debut_motsclefs=strpos($text,"keyword"))
	{
		return;
	}
	$debut_motsclefs+=19;
	while (($car=substr($text,$debut_motsclefs,1))!=chr(34))
	{
		$keyword=$keyword.$car;
		$debut_motsclefs++;
	}
    $keywords= supprime_caracteres_speciaux(supprime_accents($keyword));
	$keywords= ereg_replace(","," ",$keywords);
	$keywords= ereg_replace("[[:blank:]]+"," ",$keywords);
	$indice=0;
	for($token=strtok($keywords," ");$token!="";$token=strtok(" "))
		{
			$result[$indice]=$token;
			$indice++;
		}
	return $result;
}


//=================================================
//cree un tableau indexe par les mot courants
function mots_courants($file='')
{
$lines = @file($file);
if (is_array($lines))
    {
    while (list($id,$word) = each($lines))
           $common[trim($word)] = 1;
    }
//else
//   $common['aaaa'] = 1;
return $common;
}

//=================================================
//highlight a string part
function highlight($word="",$string="")
{
if ($word)
    return @eregi_replace("($word)","<B style='background-color:#FFDD55;'>\\1</B>",$string);
else
    return $result;
}

//=================================================
//replace les caractres accentus
function supprime_accents($chaine)
{
return( strtr( $chaine,
"",
"AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn" ) );
}

//=================================================
//supprime les caracteres speciaux
function supprime_caracteres_speciaux($text)
{
	global $spec;
	reset ($spec);
	while ($char = each($spec))
		 {
		  $text = eregi_replace ($char[0],$char[1],$text);
		  }
	return $text;
}


//=================================================
//epure a string from all non alnum words (words can contain & and _ character)
function epure_text($text,$min_word_length=2)
{
$text = stripaccents(strtolower ($text));
$text = ereg_replace("[[:blank:]][0-9]+[[:blank:]]"," ",ereg_replace("[^[:alnum:]_&]+"," ",$text));
$text = ereg_replace("[[:blank:]][^ ]{1,$min_word_length}[[:blank:]]"," "," ".$text." ");
return trim(ereg_replace("[[:blank:]]+"," ",$text));
}

//=================================================
//Nettoye une entree
function nettoye($search)
{

$search=strip_tags(strtolower($search));
$search= supprime_accents($search);
$searchs= ereg_replace(","," ",$search);
$search= ereg_replace("[[:blank:]]"," ",$search);
$search=trim(strtolower(stripslashes($search)));
return($search);
}


//=================================================
//advanced striptags function.
//returns text and title
function html_to_plain_text($text)
{
//htmlentities
global $spec;

//replace blank characters by spaces
$text = ereg_replace("[\r\n\t]+"," ",$text);

//delete content of head, script, and style tags
$text = eregi_replace("<head[^<>]*>.*</head>"," ",$text);
$text = eregi_replace("<script[^>]*>.*</script>"," ",$text);
$text = eregi_replace("<style[^>]*>.*</style>"," ",$text);
$text = eregi_replace("<form[^>]*>.*</form>","",$text);
$text = eregi_replace("(<[a-z0-9 ]+>)","\\1 ",eregi_replace("(</[a-z0-9 ]+>)","\\1 ",$text));

//tries to replace htmlentities by ascii equivalent
reset ($spec);
while ($char = each($spec))
        {
        $text = eregi_replace ($char[0]."[;]?",$char[1],$text);
        $title = eregi_replace ($char[0]."[;]?",$char[1],$title);
        }
$text = ereg_replace('&#([0-9]+);',chr('\1').' ',$text);

//replace blank characters by spaces
$text = ereg_replace("[\r\n\t]+"," ",$text);
$text = eregi_replace("--|[{}();\"]+"," ",eregi_replace("</[a-z0-9]+>"," ",$text));

//replace any group of blank characters by an unique space
$text = ereg_replace("[[:blank:]]+"," ",strip_tags($text));
$text=ereg_replace(",","",$text);
return $text;
}


?>